import React, { createElement, PureComponent } from 'react';
import PropTypes from 'prop-types';
import memoizeOne from 'memoize-one';
import { create } from 'nano-css';
import { addon } from 'nano-css/addon/cache';
import { addon as addon$1 } from 'nano-css/addon/nesting';
import { addon as addon$2 } from 'nano-css/addon/rule';
import { addon as addon$3 } from 'nano-css/addon/unitless';
import { addon as addon$4 } from 'nano-css/addon/jsx';
import { addon as addon$5 } from 'nano-css/addon/emmet';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

// The minimal theme that is required right now...
var theme = {
  fadedWhite: '#FAFAFA',
  fadedBlack: '#424242',
  borderBlack: '#B0BEC5',
  // Blue Grey 200
  light: {
    primary: '#00897B',
    // Teal 600
    primaryFg: '#FAFAFA',
    // Grey 50
    secondary: '#FFB300',
    // Amber 600
    secondaryFg: '#212121',
    // Grey  900
    disabled: '#F5F5F5',
    // Grey 100
    disabledFg: '#E0E0E0' // Grey 300

  }
};

var KamamanaContext = React.createContext(theme);
var KamamanaProvider = function KamamanaProvider(_ref) {
  var children = _ref.children,
      kTheme = _ref.kTheme;
  return React.createElement(KamamanaContext.Provider, {
    value: kTheme
  }, children);
};
KamamanaProvider.propTypes = {
  kTheme: PropTypes.object.isRequired,
  children: PropTypes.node.isRequired
};
var KamamanaConsumer = KamamanaContext.Consumer;

var nano = create({
  pfx: 'kamamana-',
  h: createElement
}); // Add addons you would like to use.

addon(nano);
addon$1(nano);
addon$2(nano);
addon$3(nano);
addon$4(nano);
addon$5(nano); // Supports Emmet abbreviations

var rule = nano.rule,
    jsx = nano.jsx;

var Button = jsx('button', {
  d: 'flex',
  ai: 'center',
  bxz: 'border-box',
  bdrs: '2px',
  fz: '16px',
  lh: 1.4,
  m: '0 8px 15px 0',
  p: '8px 15px',
  cur: 'pointer',
  trs: 'all 0.3s ease-out',
  '&:focus': {
    ol: 'none'
  },
  '& .btn-icon': {
    h: 16,
    w: 16
  },
  '& .btn-text': {
    fz: '1em'
  },
  '& .btn-icon + .btn-text': {
    ml: '8px'
  }
}, 'ButtonStyled');
var disabledCSS = function disabledCSS(context) {
  return {
    cur: 'not-allowed',
    bgc: context.light.disabled,
    c: context.light.disabledFg,
    bd: "1px solid ".concat(context.light.disabledFg)
  };
};

// https://github.com/facebook/flow/issues/7318, for details on predicate flow functions

/**
 * @param {any} string Accepts any type of argument
 * @returns {boolean} If is a proper string return `true`
 */
var isString = function isString(string) {
  return typeof string === 'string' || string instanceof String;
};
/**
 * Checks for a string | number, to be proper Number type
 * @param {any} number Accepts any type of argument
 * @returns {boolean} `true` if passed argument is a proper number
 */

var isNumber = function isNumber(number) {
  return typeof number === 'string' && !isNaN(parseInt(number)) || typeof number === 'number' || number instanceof Number;
};
/**
 * Passes only for Array|Object.
 * @param {any} obj Accepts any type of argument
 * @returns {boolean} `true` if passed argument is Object type, which is true for evry non-primitive type of variables in js
 */

var isObject = function isObject(obj) {
  return obj != null && !(obj instanceof String || obj instanceof Number || obj instanceof Boolean) && _typeof(obj) === 'object';
};

/**
 * Shallowly Compares an Object to one level down.
 * O(n) complexity for `shallowProps`. so looks ok for now.
 * @param {Array<any>} newArgs New Arguments that needs to compared to `oldArgs`
 * @param {Array<any>} oldArgs Old Arguments
 * @returns {boolean} True if shallow comparison passes for every argument.
 */

var shouldUpdateMemoize = (function (newArgs, oldArgs) {
  return newArgs.length === oldArgs.length && newArgs.every(function (newArg, index) {
    if (isObject(newArg) && isObject(oldArgs[index])) {
      return Object.keys(newArg).every( // Helps in one level down shallow comparison for objects...
      function (key) {
        if (newArg.hasOwnProperty(key) && oldArgs[index].hasOwnProperty(key)) {
          return newArg[key] === oldArgs[index][key];
        }

        return false;
      });
    }

    return newArg === oldArgs[index];
  });
});

/**
 * Composes Passed Functions from left to right
 * @param {Functions} fns Function Arguments, that is taken as an Array<Function>
 * @returns {Function} Composed Function, which accepts params similar to the left-most passed Function Arguments
 *    and Outputs the result from the right-most passed Function
 */
var compose = (function () {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return fns.reduce(function (composedFn, fn) {
    return function () {
      return fn(composedFn.apply(void 0, arguments));
    };
  });
});

/**
 * Returns and array of [r, g, b], else []
 * @param {string} rgbString RGB string of format rgb(r, g, b)
 */

var splitRGBfromRGBString = function splitRGBfromRGBString(rgbString) {
  var result = /^rgb\(\s*?(\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\s*\)$/i.exec(rgbString);
  return result ? result.splice(1) : [];
};
/**
 * Returns Decimal value for Hex strings
 * @param {string} hexString three/six characters hex string to convert to decimal number array
 * @returns {Array} Decimal Integers for Hex Values
 */

var extractIntegerFromHexString = function extractIntegerFromHexString(hexString) {
  // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;

  var _hex = hexString && hexString.replace(shorthandRegex, function (m, r, g, b) {
    return "#".concat(r + r).concat(g + g).concat(b + b);
  });

  var result = _hex ? /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(_hex) : [];
  return result ? result.splice(1).map(function (val) {
    return parseInt(val, 16);
  }) : [];
};
/**
 * @param {number} c Convert a Decimal number from 0 - 255, to it's respective hex value
 * @returns {string} Hex Value of a passed decimal value
 */

var componentToHex = function componentToHex(c) {
  if (c / 255 < 0 || c / 255 > 1) {
    return null;
  }

  var hex = c.toString(16);
  return hex.length === 1 ? "0".concat(hex) : hex;
};
/**
 * Excepts a string of format `rgb(r, g, b)`
 * @param {string | object} rgb RGB CSS String or Color Object to convert to Hex
 * @returns {string} CSS compatible Hex string
 */

var rgbToHex = function rgbToHex(rgb) {
  var r, g, b;

  if (!rgb) {
    return null;
  }

  if (typeof rgb === 'string') {
    var _splitRGBfromRGBStrin = splitRGBfromRGBString(rgb).map(function (val) {
      return componentToHex(parseInt(val));
    });

    var _splitRGBfromRGBStrin2 = _slicedToArray(_splitRGBfromRGBStrin, 3);

    r = _splitRGBfromRGBStrin2[0];
    g = _splitRGBfromRGBStrin2[1];
    b = _splitRGBfromRGBStrin2[2];
  } else if (_typeof(rgb) === 'object' && rgb.hasOwnProperty('r')) {
    r = componentToHex(parseInt(rgb.r));
    g = componentToHex(parseInt(rgb.g));
    b = componentToHex(parseInt(rgb.b));
  }

  return r && g && b ? "#".concat(r).concat(g).concat(b) : null;
};
/**
 * @param {string} hex CSS Compatible Hex String
 * @returns {object} Color Object {r, g, b}
 */

var hexToRgb = function hexToRgb(hex) {
  var _extractIntegerFromHe = extractIntegerFromHexString(hex),
      _extractIntegerFromHe2 = _slicedToArray(_extractIntegerFromHe, 3),
      r = _extractIntegerFromHe2[0],
      g = _extractIntegerFromHe2[1],
      b = _extractIntegerFromHe2[2];

  return !isNaN(r) && !isNaN(g) && !isNaN(b) ? {
    r: r,
    g: g,
    b: b
  } : null;
};
/**
 * Converts the number to be in the range from 0 - 100
 * @param {number} amount any number
 * @return {number} Amount between 0 - 100
 */

var getBoundedChangeAmount = function getBoundedChangeAmount(amount) {
  var _amount = amount < 0 ? 0 : amount > 100 ? 100 : amount;

  return _amount / 100 * 255;
};
/**
 * Shader helps in Lighten / Darken the Color by the given amount.
 * NOTE: This method is not the efficient way for lightening the colors.. Will understand and figure things out later
 * v0.1 :P
 * It's easiest possible way to shade colors, help taken from https://stackoverflow.com/a/13542669/2849127
 * @param {object} color Color Object
 * @param {number} amount Percent Value between 0 - 100, by which shader should lighten/darken the color
 */

var shader = function shader(color, amount) {
  if (color && color.hasOwnProperty('r') && color.hasOwnProperty('g') && color.hasOwnProperty('b')) {
    var r = color.r,
        g = color.g,
        b = color.b;
    r = r + amount;
    g = g + amount;
    b = b + amount;
    return {
      r: r > 255 ? 255 : r < 0 ? 0 : Math.round(r),
      g: g > 255 ? 255 : g < 0 ? 0 : Math.round(g),
      b: b > 255 ? 255 : b < 0 ? 0 : Math.round(b)
    };
  }

  return color;
};
/**
 * Lightens the Color by the given amount
 * @param {object} color Color Object to work with
 * @param {number} amount Amount by which the Color should get lighten
 */

var lighten = function lighten(color, amount) {
  return shader(color, getBoundedChangeAmount(amount));
};
/**
 * Darkens the Color by the given amount
 * @param {object} color Color Object to work with
 * @param {number} amount Amount by which the Color should get Darken
 */

var darken = function darken(color, amount) {
  return shader(color, -getBoundedChangeAmount(amount));
};
/**
 * Checks if the given color is Dark or Light
 * Help taken from https://github.com/mapbox/react-colorpickr/blob/5c7d8498c539a99c1330a83b4c7d6a79b7daaff9/src/colorfunc.js#L6
 * @param {object} color Color Object
 * @returns {boolean}
 */

var isDark = function isDark(color) {
  if (color) {
    var r = color.r,
        g = color.g,
        b = color.b;
    return !(r * 0.299 + g * 0.587 + b * 0.114 > 186);
  }

  return false;
};
/**
 * Composed Function to verify a CSS Hex String is Dark or Bright
 * @param {string} hexString CSS compatible Hex String
 * @returns {boolean}
 */

var isDarkHex = compose(hexToRgb, isDark);
/**
 * Lightens a color in Hex format by the given amount
 * @param {number} amount Amount by which the Hex Color should get lighten to
 * @return {string} CSS Compatible Hex String, after getting lighter
 */

var lightenHexToAmount = function lightenHexToAmount(amount) {
  return compose(hexToRgb, function (rgbColor) {
    return lighten(rgbColor, amount);
  }, rgbToHex);
};
/**
 * Darkens a color in Hex format by the given amount
 * @param {number} amount Amount by which the Hex Color should get lighten to
 * @return {string} CSS Compatible Hex String, after getting darker
 */

var darkenHexToAmount = function darkenHexToAmount(amount) {
  return compose(hexToRgb, function (rgbColor) {
    return darken(rgbColor, amount);
  }, rgbToHex);
};
/**
 * Converts a RGB Object / Hex String to `rgba()` string, with passed alpha, or RGBA Object to `rgba()` string with the same alpha value
 * @param {string | object} color Either a Hex String or a Color Object
 * @param {number} alpha a number between 0-1, that replaces Colors alpha channel if not present already
 * @returns {string} rgba(r, g, b, a) string
 */

var rgba = function rgba(color) {
  var alpha = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.5;

  var _rgba = isString(color) ? hexToRgb(color) : color;

  return _rgba ? "rgba(".concat(_rgba.r, ", ").concat(_rgba.g, ", ").concat(_rgba.b, ", ").concat(_rgba.a || alpha, ")") : '';
};

var darkenHexByTen = darkenHexToAmount(10);

var Button$1 =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Button$$1, _PureComponent);

  function Button$$1(props) {
    var _this;

    _classCallCheck(this, Button$$1);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Button$$1).call(this, props));

    _this.getGhostCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = 'transparent';
      var bgcHover = bgc;
      var fgc = shallowProps.style.c || btnTheme.c || shallowProps.context.fadedWhite;
      var fgcHover = shallowProps.fgcHover || shallowProps.context.light.primary;
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: fgc,
        fgcHover: fgcHover,
        bdc: shallowProps.style.bdc || btnTheme.bdc || fgc,
        bdcHover: shallowProps.bdcHover || fgcHover
      };
    };

    _this.getBorderedCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = shallowProps.context.fadedWhite;
      var bgcHover = bgc;
      var fgc = shallowProps.style.c || btnTheme.c || shallowProps.context.fadedBlack;
      var fgcHover = shallowProps.fgcHover || shallowProps.context.light.primary;
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: fgc,
        fgcHover: fgcHover,
        bdc: shallowProps.style.bdc || btnTheme.bdc || fgc,
        bdcHover: shallowProps.bdcHover || fgcHover
      };
    };

    _this.getDefaultCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = shallowProps.style.bgc || btnTheme.bgc || shallowProps.context.light.primary;
      var bgcHover = shallowProps.bgcHover || darkenHexByTen(shallowProps.style.bgc || btnTheme.bgc || shallowProps.context.light.primary);
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: shallowProps.style.c || btnTheme.c || shallowProps.context.fadedWhite,
        fgcHover: shallowProps.fgcHover || (isDarkHex(bgcHover) ? shallowProps.context.fadedWhite : shallowProps.context.fadedBlack),
        bdc: shallowProps.style.bdc || btnTheme.bdc || bgc,
        bdcHover: shallowProps.bdcHover || bgcHover
      };
    };

    _this.getCSSFromType = function (type, shallowProps) {
      switch (type) {
        case 'ghost':
          return _this.getGhostCSS(shallowProps);

        case 'bordered':
          return _this.getBorderedCSS(shallowProps);

        default:
          return _this.getDefaultCSS(shallowProps);
      }
    };

    _this.getCSS = function (type, shallowProps) {
      var css = _this.getCSSFromType(type, shallowProps);

      var iconSize = {};

      if (shallowProps.iconH && shallowProps.iconW) {
        iconSize.h = shallowProps.iconH;
        iconSize.w = shallowProps.iconW;
      }

      var outlineRGB = hexToRgb(css.bdcHover);
      var focusColor = outlineRGB ? function (opacity) {
        return "rgba(".concat(outlineRGB.r, ", ").concat(outlineRGB.g, ", ").concat(outlineRGB.b, ", ").concat(opacity, ")");
      } : function (opacity) {
        return "rgba(0, 0, 0, ".concat(opacity, ")");
      };
      return _extends({
        bgc: css.bgc,
        c: css.fgc,
        bd: "1px solid ".concat(css.bdc),
        '&:hover, &:focus': {
          '&:not([disabled])': {
            bgc: css.bgcHover,
            c: css.fgcHover,
            bd: "1px solid ".concat(css.bdcHover)
          }
        },
        '&:focus': {
          bxsh: "0 0 3px 2px ".concat(focusColor(0.3), ", 0 0 0 2px ").concat(focusColor(0.1))
        },
        '& .btn-icon': iconSize,
        '&[disabled], &.disabled': disabledCSS(shallowProps.context)
      }, shallowProps.style);
    };

    _this.getIconNode = function (icon) {
      if (icon && React.Children.count(icon)) {
        var className = icon.props.className ? "".concat(icon.props.className, " btn-icon") : "btn-icon";
        return React.cloneElement(icon, {
          className: className
        }, icon.props.children);
      }

      return null;
    };

    _this.renderButton = function (context) {
      var _this$props = _this.props,
          style = _this$props.style,
          bgcHover = _this$props.bgcHover,
          fgcHover = _this$props.fgcHover,
          bdcHover = _this$props.bdcHover,
          type = _this$props.type,
          block = _this$props.block,
          text = _this$props.text,
          disabled = _this$props.disabled,
          icon = _this$props.icon,
          iconW = _this$props.iconW,
          iconH = _this$props.iconH,
          className = _this$props.className,
          rest = _objectWithoutProperties(_this$props, ["style", "bgcHover", "fgcHover", "bdcHover", "type", "block", "text", "disabled", "icon", "iconW", "iconH", "className"]);

      var shallowProps = {
        context: context,
        style: style,
        bgcHover: bgcHover,
        fgcHover: fgcHover,
        bdcHover: bdcHover,
        iconH: iconH,
        iconW: iconW
      };

      var css = _this.getMemoizedCSS(type, shallowProps);

      return React.createElement(Button, _extends({
        css: css,
        disabled: disabled,
        className: className
      }, rest), _this.getIconNode(icon), text && React.createElement("span", {
        className: "btn-text"
      }, text));
    };

    _this.getMemoizedCSS = memoizeOne(_this.getCSS, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Button$$1, [{
    key: "render",
    value: function render() {
      return React.createElement(KamamanaConsumer, null, this.renderButton);
    }
  }]);

  return Button$$1;
}(PureComponent);

Button$1.propTypes = {
  // Styles specific Props
  style: PropTypes.object.isRequired,
  bgcHover: PropTypes.string,
  // Background Hover Color
  fgcHover: PropTypes.string,
  // Text Hover Color
  bdcHover: PropTypes.string,
  // Text Hover Color
  type: PropTypes.oneOf(['bordered', 'ghost']),
  block: PropTypes.bool,
  // Button-DOM Specific Props
  disabled: PropTypes.bool,
  text: PropTypes.string,
  icon: PropTypes.element,
  iconW: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  iconH: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  // Default Props
  className: PropTypes.string
};
Button$1.defaultProps = {
  style: {}
};

// Default Theme Object used by this module, Should be overriden and passed to components

var CardStyled = jsx('div', {
  bxz: 'border-box',
  bdrs: '2px',
  fz: '16px',
  lh: 1.4,
  p: '15px',
  bxsh: '0 0 15px -8px rgba(0,0,0,0.1), 0 2px 5px rgba(0,0,0,0.2)'
}, 'CardStyled');

var CardTitleStyled = jsx('div', {
  fz: 24,
  mb: 15
}, 'CardTitleStyled');

var CardTitle =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CardTitle, _React$PureComponent);

  function CardTitle() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CardTitle);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CardTitle)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getCSS = function (context) {
      return _extends({
        c: 'inherit'
      }, _this.props.style);
    };

    return _this;
  }

  _createClass(CardTitle, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style;
      return React.createElement(KamamanaConsumer, null, function (context) {
        return React.createElement(CardTitleStyled, {
          css: _this2.getCSS(context),
          className: className
        }, _this2.props.children);
      });
    }
  }]);

  return CardTitle;
}(React.PureComponent);

CardTitle.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string.isRequired,
  style: PropTypes.object.isRequired
};
CardTitle.defaultProps = {
  className: 'title',
  style: {}
};

var CardContentStyled = jsx('div', {}, 'CardContentStyled');

var lightenHexBy10 = lightenHexToAmount(10);

var CardContent =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CardContent, _React$PureComponent);

  function CardContent() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CardContent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CardContent)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getCSS = function (context) {
      return _extends({
        c: 'inherit'
      }, _this.props.style);
    };

    return _this;
  }

  _createClass(CardContent, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style;
      return React.createElement(KamamanaConsumer, null, function (context) {
        return React.createElement(CardContentStyled, {
          css: _this2.getCSS(context),
          className: className
        }, _this2.props.children);
      });
    }
  }]);

  return CardContent;
}(React.PureComponent);

CardContent.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string.isRequired,
  style: PropTypes.object.isRequired
};
CardContent.defaultProps = {
  className: 'content',
  style: {}
};

var Card =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Card, _React$PureComponent);

  function Card(props) {
    var _this;

    _classCallCheck(this, Card);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Card).call(this, props));

    _this.getTitle = function (css) {
      if (!_this.props.title) {
        return null;
      } else if (!isString(_this.props.title) && React.Children.count(_this.props.title) === 1 && React.Children.only(_this.props.title).type === CardTitle) {
        return _this.props.title;
      }

      return React.createElement(CardTitle, {
        style: css
      }, _this.props.title);
    };

    _this.getContent = function (css) {
      if (!isString(_this.props.children) && React.Children.count(_this.props.children) === 1 && React.Children.only(_this.props.children).type === CardContent) {
        return _this.props.children;
      }

      return React.createElement(CardContent, {
        style: css
      }, _this.props.children);
    };

    _this.getCSS = function (shallowProps) {
      return _extends({
        c: shallowProps.context.fadedBlack,
        bgc: shallowProps.context.fadedWhite
      }, shallowProps.style);
    };

    _this.renderCard = function (context) {
      var shallowProps = {
        context: context,
        style: _this.props.style
      };

      var css = _this.getMemoizedCSS(shallowProps);

      return React.createElement(CardStyled, {
        css: css
      }, _this.getTitle(css), _this.getContent(css));
    };

    _this.getMemoizedCSS = memoizeOne(_this.getCSS, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Card, [{
    key: "render",
    value: function render() {
      return React.createElement(KamamanaConsumer, null, this.renderCard);
    }
  }]);

  return Card;
}(React.PureComponent);

Card.propTypes = {
  title: PropTypes.node,
  style: PropTypes.object.isRequired,
  children: PropTypes.node
};
Card.defaultProps = {
  style: {}
};

var Container = jsx('div', {
  d: 'flex',
  fxd: 'column'
}, 'FlexContainer');

var FlexItem = jsx('div', {
  d: 'flex',
  fxd: 'row',
  fx: '1 1 100%'
}, 'FlexRow');

var FlexItem$1 = jsx('div', {
  fxg: 1,
  fxs: 1
}, 'FlexColumn');

var Column =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Column, _React$PureComponent);

  // Keeping it similar to bootstrap column counts
  function Column(props) {
    var _this;

    _classCallCheck(this, Column);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Column).call(this, props));
    _this.totalSpan = 12;

    _this.getCSS = function (shallowProps) {
      var fxb = '50%';

      if (isNumber(shallowProps.span)) {
        fxb = "".concat(parseInt(shallowProps.span, 10) / _this.totalSpan * 100, "%");
      }

      return _extends({
        fxb: fxb
      }, shallowProps.style);
    };

    _this.getMemoizedCSS = memoizeOne(_this.getCSS, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Column, [{
    key: "render",
    value: function render() {
      var shallowProps = {
        style: this.props.style,
        span: this.props.span
      };
      var css = this.getMemoizedCSS(shallowProps);
      return React.createElement(FlexItem$1, {
        css: css,
        className: Column.CLASS_NAME
      }, this.props.children);
    }
  }]);

  return Column;
}(React.PureComponent);

Column.CLASS_NAME = 'kamamana-flex-col';
Column.propTypes = {
  children: PropTypes.node,
  span: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  style: PropTypes.object.isRequired
};
Column.defaultProps = {
  style: {},
  span: 6
};

var Row =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Row, _React$PureComponent);

  function Row(props) {
    var _this;

    _classCallCheck(this, Row);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Row).call(this, props));

    _this.getGutterSize = function (gutter) {
      if (isNumber(gutter)) {
        return parseInt(gutter, 10);
      }

      return 0;
    };

    _this.getCSS = function (shallowProps) {
      var gutter = _this.getGutterSize(shallowProps.gutter);

      return _extends(_defineProperty({}, "& > .".concat(Column.CLASS_NAME, " + .").concat(Column.CLASS_NAME), {
        ml: gutter
      }), shallowProps.style);
    };

    _this.getMemoizedCSS = memoizeOne(_this.getCSS, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Row, [{
    key: "render",
    value: function render() {
      var shallowProps = {
        style: this.props.style,
        gutter: this.props.gutter
      };
      var css = this.getMemoizedCSS(shallowProps);
      return React.createElement(FlexItem, {
        css: css,
        className: Row.CLASS_NAME
      }, this.props.children);
    }
  }]);

  return Row;
}(React.PureComponent);

Row.CLASS_NAME = 'kamamana-flex-row';
Row.propTypes = {
  children: PropTypes.node,
  style: PropTypes.object.isRequired,
  gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};
Row.defaultProps = {
  style: {},
  gutter: 15
};

var Flexbox =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Flexbox, _React$PureComponent);

  function Flexbox(props) {
    var _this;

    _classCallCheck(this, Flexbox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Flexbox).call(this, props));

    _this.getGutterSize = function (gutter) {
      if (isNumber(gutter)) {
        return parseInt(gutter, 10);
      }

      return 15;
    };

    _this.getCSS = function (shallowProps) {
      var gutter = _this.getGutterSize(shallowProps.gutter);

      return _extends(_defineProperty({}, "& > .".concat(Row.CLASS_NAME, " + .").concat(Row.CLASS_NAME), {
        mt: gutter
      }), shallowProps.style);
    };

    _this.getMemoizedCSS = memoizeOne(_this.getCSS, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Flexbox, [{
    key: "render",
    value: function render() {
      var shallowProps = {
        style: this.props.style,
        gutter: this.props.gutter
      };
      var css = this.getMemoizedCSS(shallowProps);
      return React.createElement(Container, {
        css: css,
        className: Flexbox.CLASS_NAME
      }, this.props.children);
    }
  }]);

  return Flexbox;
}(React.PureComponent);

Flexbox.CLASS_NAME = 'kamamana-flex-box';
Flexbox.propTypes = {
  children: PropTypes.node,
  style: PropTypes.object.isRequired,
  gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired
};
Flexbox.defaultProps = {
  style: {},
  gutter: 15
};

var Form =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Form, _PureComponent);

  function Form() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Form);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Form)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleSubmit = function (e) {
      e.preventDefault();
      var formData = new FormData(e.currentTarget);

      _this.props.onSubmit(formData);
    };

    _this.handleReset = function (e) {
      if (_this.props.onReset) {
        _this.props.onReset();

        return;
      }
    };

    return _this;
  }

  _createClass(Form, [{
    key: "render",
    value: function render() {
      return React.createElement("form", {
        onSubmit: this.handleSubmit,
        onReset: this.handleReset
      }, this.props.children);
    }
  }]);

  return Form;
}(PureComponent);

Form.propTypes = {
  children: PropTypes.node.isRequired,
  onSubmit: PropTypes.func.isRequired,
  onReset: PropTypes.func
};

var Container$1 = jsx('div', {
  d: 'flex',
  ai: 'center',
  '& .input-label': {
    mr: 8,
    flex: '1 0 auto'
  },
  '& .input-component': {
    flex: '1 1 100%'
  },
  '& .input-component > input': {
    w: '100%',
    fz: 16,
    lh: 1.4,
    bdrs: 2,
    bxz: 'border-box',
    p: '8px 15px',
    transition: 'border 0.3s ease-out, box-shadow 0.3s ease-out',
    '&:focus': {
      ol: 'none'
    }
  }
}, 'FormComponentStyled');

/**
 * Supported Input Types:
 *
 *  - Only text fields like `text`, `email`, `password` and related..., so as to reduce complexity
 *
 * TODO: https://www.chromium.org/developers/design-documents/create-amazing-password-forms
 */

var Input =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Input, _PureComponent);

  _createClass(Input, [{
    key: "validator",
    get: function get() {
      return this.props;
    }
  }]);

  function Input(props) {
    var _this;

    _classCallCheck(this, Input);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Input).call(this, props));

    _this.handleBlur = function (e) {
      var value = e.target.value;
    };

    _this.handleChange = function (e) {
      var value = e.target.value;

      if (_this.props.validator) {
        _this.props.validator(value) && _this.setState({
          value: value
        });
        return;
      }

      _this.setState({
        value: value
      });
    };

    _this.getDefaultCSS = function (shallowProps) {
      var inputTheme = shallowProps.context.input || {};
      var bgc = inputTheme.bgc || shallowProps.context.fadedWhite;
      var bdc = shallowProps.inputStyle.bdc || inputTheme.bdc || shallowProps.context.borderBlack;

      var _bdcHover = shallowProps.bdcHover || shallowProps.context.light.primary;

      return {
        bgc: bgc,
        bdc: bdc,
        bdcHover: _bdcHover
      };
    };

    _this.getCSSFromType = function (shallowProps) {
      switch (shallowProps.type) {
        case 'material':
          return {};

        default:
          return _this.getDefaultCSS(shallowProps);
      }
    };

    _this.getLabelSpanSize = function (span) {
      if (isNumber(span)) {
        return parseInt(span, 10);
      }

      return 150;
    };

    _this.getCSS = function (shallowProps) {
      var css = _this.getCSSFromType(shallowProps);

      var focusColor = rgba(css.bdcHover, 0.3);

      var span = _this.getLabelSpanSize(shallowProps.labelSpan);

      return _extends({
        '& .input-label': {
          fxb: "".concat(span, "px")
        },
        '& .input-component > input': _extends({
          bgc: css.bgc,
          bd: "1px solid ".concat(css.bdc),
          '&:hover, &:focus': {
            bd: "1px solid ".concat(css.bdcHover)
          },
          '&:focus': {
            bxsh: "0 0 3px 1px ".concat(focusColor, ", 0 0 0 1px ").concat(focusColor)
          }
        }, shallowProps.inputStyle)
      }, shallowProps.style);
    };

    _this.filterInputStyle = function (inputStyle) {
      var bgc = inputStyle.bgc,
          bdc = inputStyle.bdc,
          rest = _objectWithoutProperties(inputStyle, ["bgc", "bdc"]);

      return rest;
    };

    _this.getTypeAndStyles = function (htmlType, shallowProps) {
      var memoizedData = {
        type: 'text',
        css: null
      };

      switch (htmlType) {
        case 'password':
        case 'email':
        case 'url':
        case 'search':
          memoizedData.type = htmlType;
          break;

        default:
          break;
      }

      memoizedData.css = _this.getCSS(shallowProps);
      return memoizedData;
    };

    _this.renderInput = function (context) {
      var _this$props = _this.props,
          id = _this$props.id,
          className = _this$props.className,
          defaultValue = _this$props.defaultValue,
          label = _this$props.label,
          htmlType = _this$props.htmlType,
          type = _this$props.type,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          onChange = _this$props.onChange,
          style = _this$props.style,
          inputStyle = _this$props.inputStyle,
          bdcHover = _this$props.bdcHover,
          validator = _this$props.validator,
          labelSpan = _this$props.labelSpan,
          rest = _objectWithoutProperties(_this$props, ["id", "className", "defaultValue", "label", "htmlType", "type", "placeholder", "value", "onChange", "style", "inputStyle", "bdcHover", "validator", "labelSpan"]);

      var memoizedData = _this.getMemoizedData(htmlType, {
        context: context,
        type: type,
        style: style,
        labelSpan: labelSpan,
        inputStyle: inputStyle,
        bdcHover: bdcHover
      });

      return React.createElement(Container$1, {
        css: memoizedData.css
      }, label && React.createElement("label", {
        htmlFor: id,
        className: "input-label"
      }, label), React.createElement("div", {
        id: id,
        className: "input-component",
        style: _this.filterInputStyle(inputStyle)
      }, React.createElement("input", _extends({
        type: memoizedData.type,
        placeholder: placeholder,
        value: value || _this.state.value,
        onChange: onChange || _this.handleChange
      }, rest))));
    };

    _this.state = {
      value: props.defaultValue || '',
      invalid: false
    };
    _this.getMemoizedData = memoizeOne(_this.getTypeAndStyles, shouldUpdateMemoize);
    return _this;
  }

  _createClass(Input, [{
    key: "render",
    value: function render() {
      return React.createElement(KamamanaConsumer, null, this.renderInput);
    }
  }]);

  return Input;
}(PureComponent);

Input.propTypes = {
  id: PropTypes.string,
  className: PropTypes.string,
  label: PropTypes.string,
  htmlType: PropTypes.string.isRequired,
  type: PropTypes.oneOf(['material', 'default']).isRequired,
  placeholder: PropTypes.string,
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  validator: PropTypes.func,
  // styles:
  style: PropTypes.object,
  // Reflects Container Styles...
  inputStyle: PropTypes.object.isRequired,
  // Reflects Input Styles..
  bdcHover: PropTypes.string,
  labelSpan: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  // Reflects how label and input should be aligned, and grow
  // Methods...
  onChange: PropTypes.func
};
Input.defaultProps = {
  inputStyle: {},
  htmlType: 'text',
  type: 'default',
  labelSpan: 150
};

var InputButton = jsx('span', {
  d: 'inline-flex',
  ai: 'center',
  bxz: 'border-box',
  bdrs: '2px',
  fz: '16px',
  lh: 1.4,
  m: '0 8px 15px 0',
  p: '8px 15px',
  cur: 'pointer',
  trs: 'all 0.3s ease-out',
  '&:focus': {
    ol: 'none'
  },
  '& .btn-icon': {
    h: 16,
    w: 16
  },
  '& .btn-text': {
    fz: '1em',
    lh: 1.4,
    bdrs: '2px',
    m: 0,
    p: 0,
    bgc: 'transparent',
    bd: 0,
    c: 'inherit',
    cur: 'inherit',
    pointerEvents: 'none'
  },
  '& .btn-icon + .btn-text': {
    ml: '8px'
  }
}, 'InputButtonStyled');
var disabledCSS$1 = function disabledCSS(context) {
  return {
    cur: 'not-allowed',
    bgc: context.light.disabled,
    c: context.light.disabledFg,
    bd: "1px solid ".concat(context.light.disabledFg)
  };
};

var darkenHexByTen$1 = darkenHexToAmount(10);
/**
 * Supported Input Types:
 *
 *  - Only button types like `submit`, `reset` and `button`
 *
 * This Component is a total replica of Button component, w.r.t. styles.
 */

var InputButton$1 =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(InputButton$$1, _PureComponent);

  function InputButton$$1(props) {
    var _this;

    _classCallCheck(this, InputButton$$1);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InputButton$$1).call(this, props));

    _this.getGhostCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = 'transparent';
      var bgcHover = bgc;
      var fgc = shallowProps.style.c || btnTheme.c || shallowProps.context.fadedWhite;
      var fgcHover = shallowProps.fgcHover || shallowProps.context.light.primary;
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: fgc,
        fgcHover: fgcHover,
        bdc: shallowProps.style.bdc || btnTheme.bdc || fgc,
        bdcHover: shallowProps.bdcHover || fgcHover
      };
    };

    _this.getBorderedCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = shallowProps.context.fadedWhite;
      var bgcHover = bgc;
      var fgc = shallowProps.style.c || btnTheme.c || shallowProps.context.fadedBlack;
      var fgcHover = shallowProps.fgcHover || shallowProps.context.light.primary;
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: fgc,
        fgcHover: fgcHover,
        bdc: shallowProps.style.bdc || btnTheme.bdc || fgc,
        bdcHover: shallowProps.bdcHover || fgcHover
      };
    };

    _this.getDefaultCSS = function (shallowProps) {
      var btnTheme = shallowProps.context.btn || {};
      var bgc = shallowProps.style.bgc || btnTheme.bgc || shallowProps.context.light.primary;
      var bgcHover = shallowProps.bgcHover || darkenHexByTen$1(shallowProps.style.bgc || btnTheme.bgc || shallowProps.context.light.primary);
      return {
        bgc: bgc,
        bgcHover: bgcHover,
        fgc: shallowProps.style.c || btnTheme.c || shallowProps.context.fadedWhite,
        fgcHover: shallowProps.fgcHover || (isDarkHex(bgcHover) ? shallowProps.context.fadedWhite : shallowProps.context.fadedBlack),
        bdc: shallowProps.style.bdc || btnTheme.bdc || bgc,
        bdcHover: shallowProps.bdcHover || bgcHover
      };
    };

    _this.getCSSFromType = function (shallowProps) {
      switch (shallowProps.type) {
        case 'ghost':
          return _this.getGhostCSS(shallowProps);

        case 'bordered':
          return _this.getBorderedCSS(shallowProps);

        default:
          return _this.getDefaultCSS(shallowProps);
      }
    };

    _this.getCSS = function (shallowProps) {
      var css = _this.getCSSFromType(shallowProps);

      var iconSize = {};

      if (shallowProps.iconH && shallowProps.iconW) {
        iconSize.h = shallowProps.iconH;
        iconSize.w = shallowProps.iconW;
      }

      var outlineRGB = hexToRgb(css.bdcHover);
      var focusColor = outlineRGB ? function (opacity) {
        return "rgba(".concat(outlineRGB.r, ", ").concat(outlineRGB.g, ", ").concat(outlineRGB.b, ", ").concat(opacity, ")");
      } : function (opacity) {
        return "rgba(0, 0, 0, ".concat(opacity, ")");
      };
      return _extends({
        bgc: css.bgc,
        c: css.fgc,
        bd: "1px solid ".concat(css.bdc),
        '&:hover, &:focus': {
          '&:not([disabled])': {
            bgc: css.bgcHover,
            c: css.fgcHover,
            bd: "1px solid ".concat(css.bdcHover)
          }
        },
        '&:focus': {
          '&:not([disabled])': {
            bxsh: "0 0 3px 2px ".concat(focusColor(0.3), ", 0 0 0 2px ").concat(focusColor(0.1))
          }
        },
        '& .btn-icon': iconSize,
        '&[disabled], &.disabled': disabledCSS$1(shallowProps.context)
      }, shallowProps.style);
    };

    _this.getTypeAndStyles = function (htmlType, shallowProps) {
      var memoizedData = {
        type: 'submit',
        css: null
      };

      switch (htmlType) {
        case 'reset':
        case 'button':
          memoizedData.type = htmlType;
          break;

        default:
          break;
      }

      memoizedData.css = _this.getCSS(shallowProps);
      return memoizedData;
    };

    _this.getIconNode = function (icon) {
      if (icon && React.Children.count(icon)) {
        var className = icon.props.className ? "".concat(icon.props.className, " btn-icon") : "btn-icon";
        return React.cloneElement(icon, {
          className: className
        }, icon.props.children);
      }

      return null;
    };

    _this.handleClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);

        return;
      }

      var inputEle = e.target.querySelector('.btn-text'); // Trigger Custom Events: https://developer.mozilla.org/en-US/docs/Web/Guide/Events/Creating_and_triggering_events

      var event = new MouseEvent('click', {
        view: window,
        bubbles: false,
        cancelable: true
      });
      inputEle && inputEle.dispatchEvent(event);
    };

    _this.renderInput = function (context) {
      var _this$props = _this.props,
          style = _this$props.style,
          bgcHover = _this$props.bgcHover,
          fgcHover = _this$props.fgcHover,
          bdcHover = _this$props.bdcHover,
          htmlType = _this$props.htmlType,
          type = _this$props.type,
          block = _this$props.block,
          disabled = _this$props.disabled,
          text = _this$props.text,
          icon = _this$props.icon,
          iconW = _this$props.iconW,
          iconH = _this$props.iconH,
          onClick = _this$props.onClick,
          rest = _objectWithoutProperties(_this$props, ["style", "bgcHover", "fgcHover", "bdcHover", "htmlType", "type", "block", "disabled", "text", "icon", "iconW", "iconH", "onClick"]);

      var memoizedData = _this.getMemoizedData(htmlType, {
        context: context,
        type: type,
        style: style,
        bgcHover: bgcHover,
        fgcHover: fgcHover,
        bdcHover: bdcHover,
        iconH: iconH,
        iconW: iconW
      });

      return React.createElement(InputButton, _extends({
        tabIndex: 0,
        css: memoizedData.css,
        disabled: disabled,
        onClick: _this.handleClick
      }, rest), _this.getIconNode(icon), React.createElement("input", {
        tabIndex: -1,
        className: "btn-text",
        type: memoizedData.type,
        value: text,
        disabled: disabled
      }));
    };

    _this.getMemoizedData = memoizeOne(_this.getTypeAndStyles, shouldUpdateMemoize);
    return _this;
  }

  _createClass(InputButton$$1, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(KamamanaConsumer, null, function (context) {
        return _this2.renderInput(context);
      });
    }
  }]);

  return InputButton$$1;
}(PureComponent);

InputButton$1.propTypes = {
  // Styles specific Props
  style: PropTypes.object.isRequired,
  bgcHover: PropTypes.string,
  // Background Hover Color
  fgcHover: PropTypes.string,
  // Text Hover Color
  bdcHover: PropTypes.string,
  // Text Hover Color
  id: PropTypes.string,
  className: PropTypes.string,
  htmlType: PropTypes.string.isRequired,
  type: PropTypes.oneOf(['bordered', 'ghost']),
  block: PropTypes.bool,
  // Button-DOM Specific Props
  disabled: PropTypes.bool,
  text: PropTypes.string,
  icon: PropTypes.element,
  iconW: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  iconH: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  // Event Handlers
  onClick: PropTypes.func,
  onFocus: PropTypes.func,
  onBlur: PropTypes.func
};
InputButton$1.defaultProps = {
  style: {},
  htmlType: 'submit'
};

export { KamamanaProvider, KamamanaConsumer, Button$1 as Button, Card, CardTitle, CardContent, Flexbox, Column, Row, Form, Input, InputButton$1 as InputButton, nano, rule, jsx };
